unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Dialogs, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    dlgOpen: TOpenDialog;
    btOpen: TButton;
    edPath: TEdit;
    grpChars: TGroupBox;
    lstChars: TListBox;
    grpProps: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edCSlot: TEdit;
    edACnt: TEdit;
    lstStyles: TListBox;
    Label3: TLabel;
    Label4: TLabel;
    edHNum: TEdit;
    edFNum: TEdit;
    btCharDel: TButton;
    btSAdd: TButton;
    btSDel: TButton;
    btSave: TButton;
    grpHStyles: TGroupBox;
    dlgSave: TSaveDialog;
    btNew: TButton;
    grpFiles: TGroupBox;
    lstFiles: TListBox;
    btFAdd: TButton;
    btFDel: TButton;
    btCharAdd: TButton;
    popChars: TPopupMenu;
    mChars: TMenuItem;
    fChars: TMenuItem;
    ZACK: TMenuItem;
    JANNLEE: TMenuItem;
    EIN: TMenuItem;
    HAYABUSA: TMenuItem;
    GENFU: TMenuItem;
    LEON: TMenuItem;
    BASS: TMenuItem;
    HAYATE: TMenuItem;
    ELIOT: TMenuItem;
    BRAD: TMenuItem;
    BAYMAN: TMenuItem;
    RIG: TMenuItem;
    AKIRA: TMenuItem;
    JACKY: TMenuItem;
    TINA: TMenuItem;
    KASUMI: TMenuItem;
    HELENA: TMenuItem;
    KOKORO: TMenuItem;
    LEIFANG: TMenuItem;
    AYANE: TMenuItem;
    LISA: TMenuItem;
    CHRISTIE: TMenuItem;
    HITOMI: TMenuItem;
    MILA: TMenuItem;
    SARAH: TMenuItem;
    PAI: TMenuItem;
    MOMIJI: TMenuItem;
    RACHEL: TMenuItem;
    MARIE: TMenuItem;
    PHASE4: TMenuItem;
    NYOTENGU: TMenuItem;
    HONOKA: TMenuItem;
    RAIDOU: TMenuItem;
    edBVer: TEdit;
    Label5: TLabel;
    procedure btOpenClick(Sender: TObject);
    procedure lstCharsClick(Sender: TObject);
    procedure lstStylesClick(Sender: TObject);
    procedure btCharDelClick(Sender: TObject);
    procedure ClearUI();
    procedure btSAddClick(Sender: TObject);
    procedure btSDelClick(Sender: TObject);
    procedure edCSlotChange(Sender: TObject);
    procedure edACntChange(Sender: TObject);
    procedure edFNumChange(Sender: TObject);
    procedure edHNumChange(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btFAddClick(Sender: TObject);
    procedure btFDelClick(Sender: TObject);
    procedure btCharAddClick(Sender: TObject);
    procedure AddChar(Sender: TObject);
    procedure btNewClick(Sender: TObject);
    procedure edBVerChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;
  rFile, wFile: TFileStream;
  dlcDat, eNames, uNames: TStringList;
  bcmCont: array of array of byte;
  cosFl: array of array of string;
  nmDat: array of array of word;
  fOffs, cosFSz: array of dword;
  strA, strB, dlName, dlPath: string;
  numA: dword;
  bcmVer, cosNum: byte;
  eFlag: boolean;
const
  chrInd: array[0..46] of string = ('ZACK', 'TINA', 'JANNLEE', 'EIN', 'HAYABUSA',
    'KASUMI', 'GENFU', 'HELENA', 'LEON', 'BASS', 'KOKORO', 'HAYATE', 'LEIFANG',
    'AYANE', 'ELIOT', 'LISA', 'ALPHA152', '?17', '?18', 'BRAD', 'CHRISTIE',
    'HITOMI', '?22', '?23', 'BAYMAN', '?25', '?26', '?27', '?28', 'RIG', 'MILA',
    'AKIRA', 'SARAH', 'PAI', '?34', '?35', '?36', '?37', '?38', 'MOMIJI',
    'RACHEL', 'JACKY', 'MARIE', 'PHASE4', 'NYOTENGU', 'HONOKA', 'RAIDOU');
  flOrd: array[0..12] of string = ('.TMC', '.TMCL', '.---C', '1.--H', '1.--HL',
    '2.--H', '2.--HL', '3.--H', '3.--HL', '4.--H', '4.--HL', '.--P', '');
  numKey: string = '0123456789';

implementation

{$R *.dfm}

procedure SaveBin();                                                                      
var
  tSList: TStringList;
  flNms: array of array of string;
  nInd : integer;
  hdSz, y: word;
  x: byte;
begin
  SetLength(flNms, Length(nmDat));
  for x := 0 to High(nmDat) do SetLength(flNms[x], nmDat[x, 0]);
  if dlcDat.Count = 0 then
  begin
    dlcDat.LoadFromFile(ExtractFileDir(ParamStr(0)) + '\dlc5lr.dat');
    eNames := TStringList.Create;
    uNames := TStringList.Create;
    tSList := TStringList.Create;
    tSList.Delimiter := Char(9);
    for y := 0 to (dlcDat.Count - 1) do
    begin
      tSList.DelimitedText := dlcDat.Strings[y];
      eNames.Add(tSList[0]);
      uNames.Add(tSList[1]);
      tSList.Clear;
    end;
    tSList.Free;
  end;
  for y := 0 to High(bcmCont) do
  begin
    if bcmCont[y, 1] < 9 then
      strA := chrInd[bcmCont[y, 0]] + '_DLCU_00' + IntToStr(bcmCont[y, 1] + 1) + '.TMC'
    else
      strA := chrInd[bcmCont[y, 0]] + '_DLCU_0' + IntToStr(bcmCont[y, 1] + 1) + '.TMC';
    nInd := uNames.IndexOf(strA);
    if nInd < 0 then
    begin
      ShowMessage('Error: filename for ' + chrInd[bcmCont[y, 0]] + ':[' + IntToStr(bcmCont[y, 1]) + '] not found in database.');
      eFlag := True;
      Exit;
    end;
    nmDat[y, 1] := nInd;
    for x := 0 to (High(flNms[y]) - 1) do
      flNms[y, x] := '/' + eNames.Strings[nInd + x] + Char(0);
    strA := ChangeFileExt(strA, '.--P');
    nInd := uNames.IndexOf(strA);
    nmDat[y, 2] := nInd;
    flNms[y, High(flNms[y])] := '/' + eNames.Strings[nInd] + Char(0);
  end;
  wFile := TFileStream.Create(dlPath + 'data\' + dlName + '.bin', fmCreate, fmShareDenyWrite);
  strA := 'LFMO'; wFile.WriteBuffer(strA[1], 4);
  numA := $1; wFile.WriteBuffer(numA, 4);
  numA := 0;
  for y := 0 to High(nmDat) do numA := numA + nmDat[y, 0];
  SetLength(fOffs, numA);
  hdSz := 27 + ((numA + 1) * 12);
  wFile.WriteBuffer(numA, 4);
  numA := $20; wFile.WriteBuffer(numA, 4);
  numA := $28; wFile.WriteBuffer(numA, 4);
  numA := hdSz + 1; wFile.WriteBuffer(numA, 4);
  numA := hdSz + Length(dlName) + 29; wFile.WriteBuffer(numA, 4);
  wFile.Seek(8, soFromCurrent);
  numA := hdSz + 1; wFile.WriteBuffer(numA, 4);
  wFile.Seek(8, soFromCurrent);
  wFile.Seek(hdSz + 1, soFromBeginning);
  strA := '_output/costume_pack_' + dlName + Char(0) + 'order' + Char(0);
  wFile.WriteBuffer(strA[1], Length(strA));
  numA := 0;
  for y := 0 to High(flNms) do
    for x := 0 to High(flNms[y]) do
    begin
      fOffs[numA] := wFile.Position;
      Inc(numA);
      strA := flNms[y, x]; wFile.WriteBuffer(strA[1], Length(strA));
    end;
  wFile.Seek(40, soFromBeginning);
  for y := 0 to High(fOffs) do
  begin
    wFile.Seek(4, soFromCurrent);
    numA := y; wFile.WriteBuffer(numA, 4);
    numA := fOffs[y]; wFile.WriteBuffer(numA, 4);
  end;
  wFile.Free;
end;

procedure SaveLnk();
var
  hdSz: dword;
  y: word;
  x: byte;
begin
  wFile := TFileStream.Create(dlPath + 'data\' + dlName + '.lnk', fmCreate, fmShareDenyWrite);
  strA := 'PCDM'; wFile.WriteBuffer(strA[1], 4);
  wFile.Seek(4, soFromCurrent);
  numA := Length(fOffs); wFile.WriteBuffer(numA, 4);
  wFile.Seek(4, soFromCurrent);
  hdSz := 32 + Length(fOffs)*32;
  if (hdSz mod 2048) > 0 then hdSz := (hdSz div 2048)*2048 + 2048;
  SetLength(cosFSz, Length(fOffs));
  wFile.Seek(hdSz, soFromBeginning);
  numA := 0;
  for y := 0 to High(cosFl) do
    for x := 0 to High(cosFl[y]) do
      if cosFl[y, x] <> '' then
      begin
        fOffs[numA] := wFile.Position;
        rFile := TFileStream.Create(cosFl[y, x], fmShareDenyWrite);
        cosFSz[numA] := rFile.Size;
        wFile.CopyFrom(rFile, rFile.Size);
        if (rFile.Size mod 2048) > 0 then
          wFile.Seek((2048 - (rFile.Size mod 2048)), soFromCurrent);
        rFile.Free;
        Inc(numA);
      end;
  x := 0; wFile.Seek(-1, soFromCurrent); wFile.WriteBuffer(x, 1);
  wFile.Seek(16, soFromBeginning);
  numA := wFile.Size; wFile.WriteBuffer(numA, 4);
  wFile.Seek(4, soFromCurrent);
  numA := $800; wFile.WriteBuffer(numA, 4);
  for y := 0 to High(fOffs) do
  begin
    wFile.Seek(4, soFromCurrent);
    numA := fOffs[y]; wFile.WriteBuffer(numA, 4);
    wFile.Seek(4, soFromCurrent);
    numA := cosFSz[y]; wFile.WriteBuffer(numA, 4);
    wFile.Seek(4, soFromCurrent); wFile.WriteBuffer(numA, 4);
    wFile.Seek(8, soFromCurrent);
  end;
  wFile.Free;
end;

procedure SaveBlp();
var
  z: word;
  x, y: byte;
begin
  wFile := TFileStream.Create(dlPath + 'data\' + dlName + '.blp', fmCreate, fmShareDenyWrite);
  strA := '1PIF'; wFile.WriteBuffer(strA[1], 4);
  numA := Length(cosFSz); wFile.WriteBuffer(numA, 4);
  numA := $10; wFile.WriteBuffer(numA, 4);
  numA := 16 + Length(cosFSz)*20; wFile.WriteBuffer(numA, 4);
  z := 0;
  for y := 0 to High(nmDat) do
  begin
    for x := 0 to (nmDat[y, 0] - 2) do
    begin
      numA := nmDat[y, 1] + x; wFile.WriteBuffer(numA, 4);
      numA := cosFSz[z]; wFile.WriteBuffer(numA, 4);
      wFile.Seek(12, soFromCurrent);
      Inc(z);
    end;
    numA := nmDat[y, 2]; wFile.WriteBuffer(numA, 4);
    numA := cosFSz[z]; wFile.WriteBuffer(numA, 4);
    wFile.Seek(12, soFromCurrent);
    Inc(z);
  end;
  x := 0; wFile.Seek(-1, soFromCurrent); wFile.WriteBuffer(x, 1);
  wFile.Free;
end;

procedure SaveBcm();
var
  cSum: DWORD;
  x, y: byte;
begin
  x := 0;
  cosNum := Length(bcmCont);
  cSum := 0;
  for y := 0 to High(bcmCont) do cSum := cSum + (bcmCont[y, 0] * bcmCont[y, 1]);
  numA := StrToInt(dlName);
  numA := ((numA + 1) * (cSum and 4095)) mod ((bcmVer * numA) + 17);
  if Length(cosFl) > 0 then
    wFile := TFileStream.Create(dlPath + dlName + '.bcm', fmCreate, fmShareDenyWrite)
  else
    wFile := TFileStream.Create(Form1.edPath.Text, fmCreate, fmShareDenyWrite);
  wFile.WriteBuffer(bcmVer, 1);
  wFile.WriteBuffer(x, 1);
  wFile.WriteBuffer(cosNum, 1);
  wFile.WriteBuffer(x, 1);
  wFile.WriteBuffer(numA, 4);
  for y:= 0 to High(bcmCont) do
    for x:= 0 to High(bcmCont[y]) do wFile.WriteBuffer(bcmCont[y, x], 1);
  wFile.Free;
end;

procedure ReadBcm();
var
  x, y: byte;
begin
  rFile := TFileStream.Create(Form1.edPath.Text, fmOpenRead, fmShareDenyWrite);
  rFile.ReadBuffer(bcmVer, 1);
  rFile.ReadBuffer(x, 1);
  if (bcmVer < 3) or (x > 0) then
  begin
    ShowMessage('Unsupported format.');
    rFile.Free;
    Exit;
  end;
  rFile.ReadBuffer(cosNum, 1);
  SetLength(bcmCont, cosNum, 6);
  rFile.Position := rFile.Position + 5;
  for y := 0 to High(bcmCont) do
  begin
    for x := 0 to 3 do rFile.ReadBuffer(bcmCont[y, x], 1);
    if bcmCont[y, 3] > 1 then SetLength(bcmCont[y], 4 + (bcmCont[y, 3] * 2));
    for x := 4 to High(bcmCont[y]) do rFile.ReadBuffer(bcmCont[y, x], 1);
    Form1.lstChars.Items.Add(chrInd[bcmCont[y, 0]]);
  end;
  Form1.edBVer.Text := IntToStr(bcmVer);
  rFile.Free;
end;

procedure TForm1.ClearUI();
begin
  lstStyles.Clear();
  lstFiles.Clear();
  edCSlot.Text := '';
  edACnt.Text := '';
  edHNum.Text := '';
  edFNum.Text := '';
end;

procedure TForm1.btSaveClick(Sender: TObject);
var
  y: word;
  x: byte;
begin
  if lstChars.Items.Count = 0 then exit;
  if edPath.Text = '' then
    if dlgSave.Execute then edPath.Text := dlgSave.FileName else exit;
  dlName := ExtractFileName(Form1.edPath.Text);
  dlName := Copy(dlName, 1, Length(dlName) - 4);
  if Length(cosFl) > 0 then
  begin
    SetLength(nmDat, Length(cosFl), 3);
    for y := 0 to High(cosFl) do
      for x := 0 to High(cosFl[y]) do
        if cosFl[y, x] <> '' then Inc(nmDat[y, 0]);
    dlPath := ExtractFilePath(Form1.edPath.Text) + '\' + dlName + '\';
    CreateDir(dlPath);
    CreateDir(dlPath + 'data\');
    SaveBcm();
    SaveBin();
    if eFlag then
    begin
      eFlag := False;
      SetLength(nmDat, 0);
      Exit;
    end
    else
    begin
      SaveLnk();
      SaveBlp();
      SetLength(nmDat, 0);
      ShowMessage('DLC saved!');
    end;
  end
  else
  begin
    SaveBcm();
    ShowMessage('BCM saved!');
  end;
end;

procedure TForm1.btOpenClick(Sender: TObject);
begin
  dlgOpen.FilterIndex := 1;
  if dlgOpen.Execute then
  begin
    lstChars.Clear();
    ClearUI();
    edPath.Text := dlgOpen.FileName;
    btCharAdd.Enabled := False;
    btCharDel.Enabled := False;
    edCSlot.Enabled := False;
    edACnt.Enabled := False;
    btFAdd.Enabled := False;
    btFDel.Enabled := False;
    SetLength(cosFl, 0);
    ReadBcm();
  end;
end;

procedure TForm1.lstCharsClick(Sender: TObject);
var
  x: byte;
begin
  if lstChars.ItemIndex = -1 then exit;
  ClearUI();
  edCSlot.Text := IntToStr(bcmCont[lstChars.ItemIndex, 1]);
  edACnt.Text := IntToStr(bcmCont[lstChars.ItemIndex, 2]);
  for x := 1 to bcmCont[lstChars.ItemIndex, 3] do
    lstStyles.Items.Add('Hairstyle ' + Char(x + 64));
  if Length(cosFl) > 0 then
    for x := 0 to High(cosFl[lstChars.ItemIndex]) do
      if cosFl[lstChars.ItemIndex, x] <> '' then
        lstFiles.Items.Add(cosFl[lstChars.ItemIndex, x]);
end;

procedure TForm1.lstStylesClick(Sender: TObject);
begin
  if lstStyles.ItemIndex = -1 then exit;
  edHNum.Text := IntToStr(bcmCont[lstChars.ItemIndex, (lstStyles.ItemIndex * 2) + 4]);
  edFNum.Text := IntToStr(bcmCont[lstChars.ItemIndex, (lstStyles.ItemIndex * 2) + 5]);
end;

procedure TForm1.btSDelClick(Sender: TObject);
var
  x: byte;
begin
  if lstChars.ItemIndex = -1 then exit;
  if lstStyles.ItemIndex = -1 then exit;
  if lstStyles.Items.Count = 1 then exit;
  if lstStyles.ItemIndex < (lstStyles.Items.Count - 1) then
  begin
    x := ((lstStyles.ItemIndex * 2) + 4);
    while x < (High(bcmCont[lstChars.ItemIndex]) - 1) do
    begin
      bcmCont[lstChars.ItemIndex, x] := bcmCont[lstChars.ItemIndex, x + 2];
      bcmCont[lstChars.ItemIndex, x + 1] := bcmCont[lstChars.ItemIndex, x + 3];
      Inc(x, 2);
    end;
  end;
  Dec(bcmCont[lstChars.ItemIndex,3]);
  SetLength(bcmCont[lstChars.ItemIndex], High(bcmCont[lstChars.ItemIndex]) - 1);
  lstCharsClick(Sender);
end;

procedure TForm1.btSAddClick(Sender: TObject);
begin
  if lstChars.ItemIndex = -1 then exit;
  lstStyles.Items.Add('Hairstyle ' + Char(bcmCont[lstChars.ItemIndex, 3] + 65));
  Inc(bcmCont[lstChars.ItemIndex, 3]);
  SetLength(bcmCont[lstChars.ItemIndex], Length(bcmCont[lstChars.ItemIndex]) + 2);
  bcmCont[lstChars.ItemIndex, High(bcmCont[lstChars.ItemIndex]) - 1] := 1;
  bcmCont[lstChars.ItemIndex, High(bcmCont[lstChars.ItemIndex])] := 1;
  lstStyles.ItemIndex := lstStyles.Items.Count - 1;
  lstStylesClick(Sender);
end;

procedure TForm1.edCSlotChange(Sender: TObject);
begin
  if lstChars.ItemIndex = -1 then exit;
  if edCSlot.Text = '' then exit;
  if Pos(edCSlot.Text[Length(edCSlot.Text)], numKey) > 0 then
    bcmCont[lstChars.ItemIndex, 1] := StrToInt(edCSlot.Text);
end;

procedure TForm1.edACntChange(Sender: TObject);
begin
  if lstChars.ItemIndex = -1 then exit;
  if (edACnt.Text = '') or (edACnt.Text = '0') then exit;
  if Pos(edACnt.Text, numKey) > 0 then
    if StrToInt(edACnt.Text) < 5 then
      bcmCont[lstChars.ItemIndex, 2] := StrToInt(edACnt.Text);
end;

procedure TForm1.edFNumChange(Sender: TObject);
begin
  if lstChars.ItemIndex = -1 then exit;
  if lstStyles.ItemIndex = -1 then exit;
  if edFNum.Text = '' then exit;
  if Pos(edFNum.Text, numKey) > 0 then
    bcmCont[lstChars.ItemIndex, (lstStyles.ItemIndex * 2) + 5] := StrToInt(edFNum.Text);
end;

procedure TForm1.edHNumChange(Sender: TObject);
begin
  if lstChars.ItemIndex = -1 then exit;
  if lstStyles.ItemIndex = -1 then exit;
  if edHNum.Text = '' then exit;
  if Pos(edHNum.Text, numKey) > 0 then
    bcmCont[lstChars.ItemIndex, (lstStyles.ItemIndex * 2) + 4] := StrToInt(edHNum.Text);
end;

procedure TForm1.btFDelClick(Sender: TObject);
var
  x: byte;
begin
  if lstFiles.ItemIndex = -1 then exit;
  for x := 0 to High(cosFl[lstChars.ItemIndex]) do
    if cosFl[lstChars.ItemIndex, x] = lstFiles.Items.Strings[lstFiles.ItemIndex] then
      cosFl[lstChars.ItemIndex, x] := '';
  lstCharsClick(Sender);
end;

procedure TForm1.btFAddClick(Sender: TObject);
var
 x, y: byte;
begin
  if lstChars.ItemIndex = -1 then exit;
  dlgOpen.FilterIndex := 2;
  if dlgOpen.Execute then
  begin
    if (lstFiles.Items.Count + dlgOpen.Files.Count) > 12 then
    begin
      ShowMessage('Files limit exceeded!');
      Exit;
    end;
    for y := 0 to (dlgOpen.Files.Count - 1) do
      for x := 0 to (High(flOrd) - 1) do
        if (Pos(flOrd[x], dlgOpen.Files.Strings[y]) > 0)
        and (Pos (flOrd[x + 1], dlgOpen.Files.Strings[y]) = 0) then
          cosFl[lstChars.ItemIndex, x] := dlgOpen.Files.Strings[y];
    lstCharsClick(Sender);
  end;
end;

procedure TForm1.btCharDelClick(Sender: TObject);
var
  x: byte;
begin
  if lstChars.ItemIndex = -1 then exit;
  if lstChars.ItemIndex < High(bcmCont) then
    for x:= lstChars.ItemIndex to (High(bcmCont) - 1) do
      begin
        SetLength(bcmCont[x], Length(bcmCont[x+1]));
        bcmCont[x] := bcmCont[x+1];
        if Length(cosFl) > 0 then
        begin
          SetLength(cosFl[x], Length(cosFl[x+1]));
          cosFl[x] := cosFl[x+1];
        end;
      end;
  SetLength(bcmCont, High(bcmCont));
  if Length(cosFl) > 0 then
    SetLength(cosFl, High(cosFl));
  lstChars.Items.Delete(lstChars.ItemIndex);
  ClearUI();
end;

procedure TForm1.AddChar(Sender: TObject);
var
  x: byte;
begin
  for x := 0 to High(chrInd) do
    if chrInd[x] = TMenuItem(Sender).Name then break;
  lstChars.Items.Add(chrInd[x]);
  SetLength(bcmCont, Length(bcmCont) + 1);
  SetLength(bcmCont[High(bcmCont)], 6);
  SetLength(cosFl, Length(cosFl) + 1);
  SetLength(cosFl[High(cosFl)], 12);
  bcmCont[High(bcmCont),0] := x;
  bcmCont[High(bcmCont),1] := 0;
  for x := 2 to 5 do bcmCont[High(bcmCont),x] := 1;
  lstChars.ItemIndex := lstChars.Items.Count - 1;
  lstCharsClick(Sender);
  lstStyles.ItemIndex := lstStyles.Items.Count - 1;
  lstStylesClick(Sender);
end;

procedure TForm1.btCharAddClick(Sender: TObject);
var
  pnt: TPoint;
begin
 if GetCursorPos(pnt) then popChars.Popup(pnt.X, pnt.Y);
end;

procedure TForm1.btNewClick(Sender: TObject);
begin
  if dlgSave.Execute then
  begin
    lstChars.Clear();
    ClearUI();
    SetLength(bcmCont, 0);
    SetLength(cosFl, 0);
    edPath.Text := dlgSave.FileName;
    btCharAdd.Enabled := True;
    btCharDel.Enabled := True;
    edCSlot.Enabled := True;
    edACnt.Enabled := True;
    btFAdd.Enabled := True;
    btFDel.Enabled := True;
    bcmVer := 9;
    edBVer.Text := IntToStr(bcmVer);
  end;
end;

procedure TForm1.edBVerChange(Sender: TObject);
begin
  if edBVer.Text = '' then exit;
  if Pos(edBVer.Text[Length(edBVer.Text)], numKey) > 0 then
    bcmVer := StrToInt(edBVer.Text);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dlcDat := TStringList.Create;
  eFlag := False;
end;

end.
